#!/usr/bin/python

# Download CryptoPhoto Python lib from https://cryptophoto.com/admin/api
from CryptoPhotoUtils import CryptoPhotoUtils
import cgi, hashlib, os

server      = "https://cryptophoto.com";
private_key = "xxx"; # Your CryptoPhoto Private API Key
public_key  = "yyy"; # Your CryptoPhoto Public API Key
salt        = "random-salt-string";
uid         = "userId"; # Your users internal ID
tvkey       = "key-of-a-transaction-verification-template"; # see https://cryptophoto.com/info/cptv-templates

POST = cgi.FieldStorage(keep_blank_values=True)

display = ''

if 'message' in POST:
  if 'cpJWSrfc7515' in POST and 'cpTVresponse' in POST:

    cp = CryptoPhotoUtils(server, private_key, public_key, hashlib.sha1(uid + salt).hexdigest())
    cp.verify_cptv_response(POST) # verify transaction response

    if cp.is_valid:
      # do something with form values based on POST['cpTVresponse'] which
      # contains the response from the transaction

      display = '<p>Message sent and received: ' + POST['cpTVresponse'].value + '</p>'
    else:
      display = '<p>' + cp.error + '</p>'

cp = CryptoPhotoUtils(server, private_key, public_key, hashlib.sha1(uid + salt).hexdigest())
cp.start_session(cgi.escape(os.environ["REMOTE_ADDR"]))

sid = ''

if cp.is_valid:
  sid = cp.sid
else:
  display += '<p>' + cp.error + cp.errdesc + '</p>'

display += ('<form action="" method="post">'
  'Message: <input type="text" name="message"><br>'
  '<input type="submit" value="Send">'
  '</form>')

if sid != '':
   display += "<script type='text/javascript' src='" + server + "/api/tv?key=" + tvkey + "&sid=" + sid + "' async='true'></script>";

out = '''Content-Type: text/html; charset=utf-8

<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Send Message</title>
</head>
<body style="text-align:center">
  <h2>Send Message</h2>
  {display}
</body>
</html>'''

out = out.format(display=display)

print out
