#!/usr/bin/python

# Download CryptoPhoto Python lib from https://cryptophoto.com/admin/api
from CryptoPhotoUtils import CryptoPhotoUtils
import cgi, hashlib, os

server      = "https://cryptophoto.com";
private_key = "xxx"; # Your CryptoPhoto Private API Key
public_key  = "yyy"; # Your CryptoPhoto Public API Key
salt        = "random-salt-string";
uid         = "userId"; # Your users internal ID
tvkey       = "key-of-a-transaction-verification-template"; # see https://cryptophoto.com/info/cptv-templates and https://cryptophoto.com/admin/api-docs#header-ecryption-and-decryption

POST = cgi.FieldStorage(keep_blank_values=True)

display = ''
value = ''
doingDecryption = False

if 'value_cpencrypt' in POST and 'value' in POST and POST['value'].value:
  if 'cpJWSrfc7515' in POST and 'cpTVresponse' in POST:

    cp = CryptoPhotoUtils(server, private_key, public_key, hashlib.sha1(uid + salt).hexdigest())
    cp.verify_cptv_response(POST) # verify transaction response

    if cp.is_valid:
      display = '<p>Value encrypted</p>'
      value = POST['value'].value
      doingDecryption = True
    else:
      display = '<p>' + cp.error + '</p>'

elif 'value_cpdecrypt' in POST and 'value' in POST and POST['value'].value:
  if 'cpJWSrfc7515' in POST and 'cpTVresponse' in POST:

    cp = CryptoPhotoUtils(server, private_key, public_key, hashlib.sha1(uid + salt).hexdigest())
    cp.verify_cptv_response(POST) # verify transaction response

    if cp.is_valid:
      display = '<p>Value decrypted</p>'
      value = POST['value'].value
      doingDecryption = False
    else:
      display = '<p>' + cp.error + '</p>'


cp = CryptoPhotoUtils(server, private_key, public_key, hashlib.sha1(uid + salt).hexdigest())
cp.start_session(cgi.escape(os.environ["REMOTE_ADDR"]))

sid = ''

if cp.is_valid:
  sid = cp.sid
else:
  display += '<p>' + cp.error + '</p>'

display += ('<form action="" method="post">'
    'Value:<br> <textarea rows="5" name="value" >' + value + '</textarea><br>')

if not doingDecryption:
    display += ('<input type="hidden" name="value_cpencrypt">'
        '<input type="submit" value="Encrypt">')
else:
    display += ('<input type="hidden" name="value_cpdecrypt">'
        '<input type="submit" value="Decrypt">')

display += '</form>'

if sid != '':
   display += "<script type='text/javascript' src='" + server + "/api/tv?key=" + tvkey + "&sid=" + sid + "' async='true'></script>";

out = '''Content-Type: text/html; charset=utf-8

<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Encrypt/Decrypt Value</title>
</head>
<body style="text-align:center">
  <h2>Encrypt/Decrypt Value</h2>
  {display}
</body>
</html>'''

out = out.format(display=display)

print out